<script setup lang="ts">
import { ref, onMounted } from "vue";
import { useQuasar } from "quasar";

import { useRouter } from "vue-router";
import http from "@/plugins/http";
import config from "@/app.config";
import { useCounterMixin } from "@/stores/mixin";

/** importType*/
import type { QTableProps } from "quasar";
import type { ItemsMenu } from "@/modules/02_users/interface/index/Main";
import type { Roles } from "@/modules/02_users/interface/response/Main";

/** importComponents*/
import DialogAddRole from "@/modules/02_users/components/Roles/DialogAddRole.vue";

/** use*/
const $q = useQuasar();
const router = useRouter();
const {
  dialogRemove,
  messageError,
  showLoader,
  hideLoader,
  success,
  onSearchDataTable,
} = useCounterMixin();

/** Table*/
const rows = ref<Roles[]>([]); // รายการบทบาท
const rowsMain = ref<Roles[]>([]); // รายการบทบาท
const keyword = ref<string>(""); // คำค้นหา
const columns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    sortable: false,
    field: "no",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "roleName",
    align: "left",
    label: "ชื่อบทบาท",
    sortable: true,
    field: "roleName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "roleDescription",
    align: "left",
    label: "คำอธิบาย",
    sortable: true,
    field: "roleDescription",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "isAdminVisibled",
    align: "left",
    label: "ผู้ดูแลระบบมองเห็น",
    sortable: true,
    field: "isAdminVisibled",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
]);
const visibleColumns = ref<string[]>([
  "no",
  "roleName",
  "roleDescription",
  "isAdminVisibled",
]); // คอลัมน์ที่แสดง

const modalDialogAdd = ref<boolean>(false); // เพิ่มบทบาท

// รายการตัวเลือก
const itemMenu = ref<ItemsMenu[]>([
  {
    label: "แก้ไข",
    icon: "edit",
    color: "edit",
    type: "edit",
  },
  {
    label: "ลบ",
    icon: "delete",
    color: "red",
    type: "delete",
  },
]);

/**
 * function fetch รายการบทบาท
 * และบันทึกใน rows
 */
async function fetchListRole() {
  showLoader();
  await http
    .get(config.API.managementAuth + `/list`)
    .then(async (res) => {
      const data = await res.data.result;
      rows.value = data;
      rowsMain.value = data;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 *  ฟังก์ชันจัดการการกระทำต่าง ๆ กับข้อมูลบทบาท
 * @param type ประเภท
 * @param data ข้อมูลรายการบทบาท
 */
function onClickAction(type: string, data: Roles) {
  // เช็คการกระทำ
  if (type === "edit") {
    // ไปหน้าจัดการสิทธิ์
    router.push(`/roles/${data.id}`);
  } else if (type === "delete") {
    // ลบรายการยบทบาท
    onDeleteRole(data.id);
  }
}

/** เปิด  popup เพิ่มบทบาท*/
function openDialog() {
  modalDialogAdd.value = true;
}

/**
 * function ยืนยันการลบข้อมูลบทบาท
 * @param id รายการบทบาท
 */
function onDeleteRole(id: string) {
  dialogRemove($q, async () => {
    showLoader();
    await http
      .delete(config.API.managementAuth + `/${id}`)
      .then(async () => {
        await fetchListRole();
        success($q, "ลบข้อมูลสำเร็จ");
      })
      .catch((err) => {
        messageError($q, err);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

function serchDataTable() {
  rows.value = onSearchDataTable(
    keyword.value,
    rowsMain.value,
    columns.value ? columns.value : []
  );
}

/**
 * hook ทำงานเมื่อมีการเรียกใช้งาน Components
 * ดึงข้อมูลบทบาท
 */
onMounted(async () => {
  await fetchListRole();
});
</script>

<template>
  <div class="row items-center">
    <div class="toptitle text-dark row items-center q-py-xs">
      จัดการบทบาทและสิทธิ์
    </div>
  </div>

  <q-card flast bordered class="q-pa-md">
    <div class="items-center col-12 row q-col-gutter-sm q-mb-sm">
      <q-btn flat round dense color="primary" icon="add" @click="openDialog()">
        <q-tooltip>เพิ่มบทบาท </q-tooltip>
      </q-btn>
      <q-space />

      <q-input
        borderless
        dense
        outlined
        v-model="keyword"
        placeholder="ค้นหา"
        @keydown.enter.prevent="serchDataTable"
      >
        <template v-slot:append>
          <q-icon name="search" />
        </template>
      </q-input>
      <q-select
        v-model="visibleColumns"
        multiple
        outlined
        dense
        options-dense
        :display-value="$q.lang.table.columns"
        emit-value
        map-options
        :options="columns"
        option-value="name"
        style="min-width: 140px"
      />
    </div>

    <div class="col-12 q-pt-sm">
      <d-table
        ref="table"
        :columns="columns"
        :rows="rows"
        row-key="id"
        flat
        bordered
        :paging="true"
        dense
        :rows-per-page-options="[10, 25, 50, 100]"
        :visible-columns="visibleColumns"
      >
        <template v-slot:header="props">
          <q-tr :props="props">
            <q-th v-for="col in props.cols" :key="col.name" :props="props">
              <span class="text-weight-medium">{{ col.label }}</span>
            </q-th>
            <q-th auto-width></q-th>
          </q-tr>
        </template>
        <template v-slot:body="props">
          <q-tr :props="props">
            <q-td v-for="col in props.cols" :key="col.name" :props="props">
              <div v-if="col.name === 'no'">
                {{ props.rowIndex + 1 }}
              </div>
              <div v-else-if="col.name === 'isAdminVisibled'">
                <q-icon
                  v-if="props.row.isAdminVisibled"
                  size="sm"
                  name="check"
                  color="primary"
                />
                <span v-else>-</span>
              </div>
              <div v-else>
                {{ col.value ? col.value : "-" }}
              </div>
            </q-td>
            <q-td auto-width>
              <q-btn
                flat
                dense
                icon="mdi-dots-vertical"
                class="q-pa-none q-ml-xs"
                color="grey-13"
                size="12px"
              >
                <q-menu>
                  <q-list dense style="min-width: 200px">
                    <q-item
                      v-for="(item, index) in itemMenu"
                      :key="index"
                      clickable
                      v-close-popup
                      @click.stop="onClickAction(item.type, props.row)"
                    >
                      <q-item-section>
                        <div class="row items-center">
                          <q-icon
                            :color="item.color"
                            size="17px"
                            :name="item.icon"
                          />
                          <div class="q-pl-md">{{ item.label }}</div>
                        </div>
                      </q-item-section>
                    </q-item>
                  </q-list>
                </q-menu>
              </q-btn>
            </q-td>
          </q-tr>
        </template>
      </d-table>
    </div>
  </q-card>

  <DialogAddRole v-model:modal="modalDialogAdd" />
  <!-- :fetchlist="fetchListRole" v-model:isStatusEdit="isStatusEdit"
  :roleId="roleId" -->
</template>

<style scoped></style>
